'===============================================================================
' Frequency_Generator.bas 
' First revision Jan 30, 2015
' Latest revision November 28, 2016
'===============================================================================

#Include "windows.bi"
#Include "GUI.bi"

Dim Shared As TrackBar Track_Freq
Dim Shared As TextBox Text_Freq
Dim Shared As Button Button_Ton
Dim Shared f As Integer = 1000


Sub CreateWindow_Main()
	'Main window
	
	OpenWindow								(450, 400, "Frequency Generator")
	Track_Freq = TrackBar_New	(20, 20, 300, 20)
	Text_Freq = TextBox_New		(330, 20, 80, 20, "")
	Var Label_Freq = Label_New(20, 40, 300, 20, "Frequency 300 to 3000 Hz")
	Button_Ton = Button_New		(170, 70, 60, 20, "Tone")
	
	TrackBar_SetRange(Track_Freq, 300, 3000)
	TrackBar_SetValue(Track_Freq, f)
	
End Sub


Function Sine(t As Double) As Double
	'Sine function
	
	Const pi = 4 * Atn(1)
		
	Return Sin(2 * pi * f * t)
	
End Function 


Sub Track_Freq_Event()
	'Read frequency from trackbar and draw sine curve
		
	Dim As Double dt = 1e-6, t
	Dim As Integer i
	
	f = TrackBar_GetValue(Track_Freq)
	TextBox_SetText(Text_Freq, Str(f))
	
	View (10, 110) - (440, 390), &hFFFFFF, &hAAAAAA
	Draw String (10, 260), "Time from 0 to 10 ms", &h000000
	Window (0, -1.5) - (0.01, 1.5)
	Line (0, 0) - (10, 0), &h000000
	
	For i = 0 To 10000
		t = i * dt
		PSet (t, Sine(t)), &hFF0000
	Next
		
	View
	Window
  	
End Sub
	

Sub Button_Ton_Event()
	'Tone
	
	Beep_(f, 1000)
	
End Sub


'Main:

CreateWindow_Main()

Do
	If TrackBar_Event(Track_Freq) Then Track_Freq_Event()
	If Button_Event(Button_Ton) Then Button_Ton_Event()
  Sleep 1
Loop Until Window_Event_Close

End


